# -*- coding: utf-8 -*-

import GBase
import googsystray
import os
import gtk, gobject
import stat
import shlex
import subprocess

if os.name == "nt":
	from _winreg import *


from xml.etree import cElementTree as ET
# cElementTree needs this on windows, but it won't get built into
# the package for some reason unless we import it.
from xml.etree import ElementTree

_w05 = "{http://www.w3.org/2005/Atom}"
_w07 = "{http://www.w3.org/2007/app}"
_g05 = "{http://schemas.google.com/g/2005}"
_g05nb = "http://schemas.google.com/g/2005"
_g08 = "{http://schemas.google.com/contact/2008}"
_g08nb = "http://schemas.google.com/contacts/2008"

import GPopupWindow, GMain

vis_notify = None
entries = []


def close_config(saved):
	return
	
def draw_config(vbox):
	return



class GContacts(GBase.GBase):

			
	def getContactsWithPhones(self):
		return self.phoneContacts
	

	def getEntry(self, node):
		title = ""
		id = ""
		givenName = ""
		familyName = ""
		nameSuffix = ""
		namePrefix = ""
		additionalName = ""
		birthday = ""
		phoneNumbers = []
		emailAddresses = []
		im = {}
		image = {}
#		ET.dump(node)
		for i in node.getchildren():
#			self.dumpit(i)
			if i.tag == _w05+"id":
				id = i.text[68:]
			elif i.tag == _w05+"title":
				title = i.text
			elif i.tag == _g05+"phoneNumber":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				phoneNumbers.append({"primary":p, "type":type, "number":i.text})
			elif i.tag == _g05+"email":
				if i.attrib.get("rel") != None:
					type = i.attrib["rel"][33:]
				else:
					type = i.attrib["label"]
				if i.attrib.get("primary"):
					p = True
				else:
					p = False
					
				emailAddresses.append({"primary":p, "type":type, "address":i.attrib["address"]})
			elif i.tag == _g05+"name":
				for j in i.getchildren():
					if j.tag == _g05+"givenName":
						givenName = j.text
					elif j.tag == _g05+"familyName":
						familyName = j.text
					elif j.tag == _g05+"nameSuffix":
						nameSuffix = j.text
					elif j.tag == _g05+"namePrefix":
						namePrefix = j.text
					elif j.tag == _g05+"additionalName":
						additionalName = j.text
					elif j.tag == _g05+"fullName":
						pass
					else:
						pass
						# fixme, popup an error
						# for the user to send me a message!
						#self.dumpit(j)
			elif i.tag == _g08+"birthday":
				birthday = i.attrib.get("when")
				# This format is YYYY-MM-DD
				# eg 1980-05-14 OR --05-14 for no year
			elif i.tag == _g08+"website":
#				self.dumpit(i)
				pass
			elif i.tag == _g05+"im":
				if i.attrib["protocol"] == _g05nb + "#AIM":
					im["aim"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#GOOGLE_TALK":
					im["gtalk"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#MSN":
					im["msn"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#YAHOO":
					im["yahoo"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#JABBER":
					im["jabber"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#QQ":
					im["qq"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#ICQ":
					im["icq"] = i.attrib["address"]
				elif i.attrib["protocol"] == _g05nb + "#SKYPE":
					im["skype"] = i.attrib["address"]
				else:
					pass
			elif i.tag == _w05+"link":
#				self.dumpit(i)
				try:
					if i.attrib["rel"] == _g08nb+"/rel#photo":
						etag = i.attrib[_g05+"etag"][1:-2]
						image = {"href": i.attrib["href"], "etag": etag}
					
				except KeyError:
					pass
			elif i.tag == _g08+"groupMembershipInfo":
				#TODO groups are important.
				pass
			elif i.tag == _g08+"relation":
				#TODO relationships, could be multiple
				pass
			elif i.tag == _g05+"structuredPostalAddress":
				#TODO save postal address
				for j in i.getchildren():
					if j.tag == _g05+"formattedAddress":
						pass
					elif j.tag == _g05+"street":
						pass
					elif j.tag == _g05+"postcode":
						pass
					elif j.tag == _g05+"city":
						pass
					elif j.tag == _g05+"region":
						pass
					else:
						self.dumpit(i)
			elif i.tag == _w05+"content":
				#TODO notes
				pass
			elif i.tag == _g05+"organization":
				for j in i.getchildren():
					if j.tag == _g05+"orgName":
						pass
					elif j.tag == _g05+"orgTitle":
						pass
					else:
						pass
#						self.dumpit(i)
			elif i.tag == _g08+"nickname":
				pass
			elif i.tag == _g08+"event":
				# i.attrib.get("rel")
				# "anniversary"/"other"
				for j in i.getchildren():
					if j.tag == _g05+"when":
						# j.attrib.get("startTime")
						pass
					else:
						pass
#						self.dumpit(i)
			elif i.tag == _g08+"userDefinedField":
				# i.attrib.get("value")
				# i.attrib.get("key")
				pass
########################The following contents, TODO eventually delete
######################## Just here to avoid dumping them
			elif i.tag == _w05+"updated":
				pass
			elif i.tag == _w07+"edited":
				pass
			elif i.tag == _w05+"category":
				pass
########################
			else:
#				self.dumpit(i)
				pass
					
				
		if title != None:
			if self.contacts.get(id) == None:
				self.contacts[id] = {}
			self.contacts[id]["title"] = title
			self.contacts[id]["phone"] = phoneNumbers
			self.contacts[id]["email"] = emailAddresses
			self.contacts[id]["givenName"] = givenName
			self.contacts[id]["familyName"] = familyName
			self.contacts[id]["nameSuffix"] = nameSuffix
			self.contacts[id]["namePrefix"] = namePrefix
			self.contacts[id]["additionalName"] = additionalName
			self.contacts[id]["birthday"] = birthday
			self.contacts[id]["image"] = image
			self.contacts[id]["im"] = im
			
			self.contacts[id]["id"] = id # yes, we need this
			

	def compare_numbers(self, phone1, phone2):
		phone1 = phone1.replace("+", "")
		phone2 = phone2.replace("+", "")
		phone1 = phone1.replace("-", "")
		phone2 = phone2.replace("-", "")
		phone1 = phone1.replace(",", "")
		phone2 = phone2.replace(",", "")
		phone1 = phone1.replace("#", "")
		phone2 = phone2.replace("#", "")
		phone1 = phone1.replace("(", "")
		phone2 = phone2.replace("(", "")
		phone1 = phone1.replace(")", "")
		phone2 = phone2.replace(")", "")
		
		if phone1[0] == '1':
			phone1 = phone1[1:]
		if phone2[0] == '1':
			phone2 = phone2[1:]
			
		if phone1 == phone2:
			return True
		
		return False
		

	def get_contact_from_email(self, email):
		for i in self.contacts.items():
			for j in i[1]["email"]:
				if j["address"] == email:
					return i[1]
		return None

	def get_contact_from_phone(self, phone):
		for i in self.contacts.items():
			for j in i[1]["phone"]:
				if self.compare_numbers(j["number"], phone):
					return i[1]
		return None
		
	def open_email(self, widget, event, contact):
		self.popup_window.destroy()
		self.popup_window = None
		
		for i in GMain._services:
			if i["service"] == "gmail":
				gm = i["class"]
		
		primary = None
		for i in contact["email"]:
			if i["primary"]:
				primary = i["address"]
		if primary is None:
			primary = contact["email"][0]["address"]
		gm.compose_email(to=primary)
		
	def open_phonecall(self, widget, event, contact):
		for i in GMain._services:
			if i["service"] == "gv":
				gv = i["class"]
		
		primary = None
		for i in contact["phone"]:
			if i["primary"]:
				primary = i["number"]
		if primary is None:
			primary = contact["phone"][0]["number"]
		gv.new_call(contact=contact)
	
	def open_sms(self, widget, event, contact):
		for i in GMain._services:
			if i["service"] == "gv":
				gv = i["class"]
		
		gv.new_sms(contact=contact)
	
	def open_contact(self, widget, event, data):
		pass

	def open_messenger(self, widget, event, data):
		(contact, messenger) = data
		try:
			config = GMain._GConf.gconfig["global"]["integrated_apps"][messenger]
		except:
			#FIXME pop up an error.
			return

		if config["type"] == 0:
			self.open_messenger_auto(widget, event, data)
		elif config["type"] == 1:
			try:
				run_command(config["command"] % contact)
			except TypeError, e:
				run_command(config["command"])

	def open_messenger_auto(self, widget, event, data):
		(contact, messenger) = data
		if messenger == "aim":
			url = "aim:goim?screenname=" + contact["im"]["aim"]
		elif messenger == "gtalk":
			url = "gtalk:chat?jid=" + contact["im"]["gtalk"]
		elif messenger == "icq":
			url = "icq:goim?screenname=" + contact["im"]["icq"]
		elif messenger == "jabber":
			url = "xmpp:" + contact["im"]["jabber"]
		elif messenger == "msn":
			url = "msnim:chat?contact=" + contact["im"]["msn"]
		elif messenger == "skype":
			url = "skype:" + contact["im"]["skype"]
		elif messenger == "yahoo":
			url = "ymsgr:sendIM?" + contact["im"]["yahoo"]
		else:
			url = "UNKNOWN"

		if os.name == "nt":
			if messenger == "gtalk":
				# Supposedly, the default would work on < Vista?
				regpath="Software\\Classes\\CLSID\\{226b64e8-dc75-4eea-a6c8-abcb496320f2}\\Google Talk"
				reg = OpenKey(HKEY_CURRENT_USER, regpath)
				try:
					app = QueryValueEx(reg, "InstallDir")[0]
					CloseKey(reg)
					GBase.run_command("\"" + str(app) + "\\googletalk.exe\" /" + url)
				except:
					#FIXME error
					pass
		
			elif messenger == "msn":
				regpath="Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\MSNMSGR.EXE"
				reg = OpenKey(HKEY_LOCAL_MACHINE, regpath)
				try:
					app = QueryValueEx(reg, None)[0]
					CloseKey(reg)
					GBase.run_command("\"" + str(app) + "\" /" + url)
				except:
					#FIXME error
					pass
				
			else:
				try:
        	                        os.startfile(url)
	                        except:
        	                        GBase.error_dialog(_("Windows does not know how to handle '%(url)s'") % {"url":url})
		else:
			cmd = "purple-url-handler " + url
			
			cmd_arr1 = shlex.split(cmd)
			subprocess.Popen(cmd_arr1)


	def icon_enter(self, widget, data=None):
		cursor = gtk.gdk.Cursor(widget.get_display(), gtk.gdk.HAND2)
		window = widget.window
		window.set_cursor(cursor)

	def icon_leave(self, widget, data=None):
		window = widget.window
		window.set_cursor(None)

			
	def create_icon(self, size, filename):
		pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.BASE_DIR, "icons", filename))
		pb2 = pb.scale_simple(size, size, gtk.gdk.INTERP_HYPER)
		image = gtk.image_new_from_pixbuf(pb2)
		ebox = gtk.EventBox()
		ebox.add(image)
		ebox.set_events(gtk.gdk.BUTTON_PRESS_MASK |
				  gtk.gdk.ENTER_NOTIFY_MASK |
				  gtk.gdk.LEAVE_NOTIFY_MASK)
		ebox.set_visible_window(False)
		ebox.connect("enter_notify_event", self.icon_enter)
		ebox.connect("leave_notify_event", self.icon_leave)
		return ebox
		
		
	def contact_clicked(self, widget, event, data):
		(contact, size, window) = data

		(m_x, m_y, m_mask) = window.window.get_screen().get_root_window().get_pointer()
		m_x -= 20
		m_y -= 20

		
		self.popup_window = GPopupWindow.get_new_popup_window_clean(
			None, None,
			m_x, m_y)

		self.popup_window.window.set_transient_for(window.window)

		hbox = gtk.HBox()
		self.popup_window.vbox.pack_start(hbox, True, True, 5)
		
		ebox = self.create_icon(size, "Google-Contacts-64.png")
		hbox.pack_start(ebox, False, False, 5)
		ebox.connect("button_press_event", self.open_contact, contact)


		
		if contact["email"] != {}:
			ebox = self.create_icon(size, "Google-gMail-64.png")
			hbox.pack_start(ebox, False, False, 5)
			ebox.connect("button_press_event", self.open_email, contact)

		acct = None
		for i in GMain._accounts:
			if i["services"]["gv"]:
				acct = i
				break

		if contact["phone"] != {} and acct is not None:
			ebox = self.create_icon(size, "phonecall.png")
			hbox.pack_start(ebox, False, False, 5)
			ebox.connect("button_press_event", self.open_phonecall, contact)
			ebox = self.create_icon(size, "Google-Voice-64.png")
			hbox.pack_start(ebox, False, False, 5)
			ebox.connect("button_press_event", self.open_sms, contact)

		for i in contact["im"]: 
			ebox = self.create_icon(size, i + ".png")
			hbox.pack_start(ebox, False, False, 5)
			ebox.connect("button_press_event", self.open_messenger, (contact, i))
		
		
		self.popup_window.show_all()
		
	def get_contact_imagename(self, contact):
		try:
			
			return os.path.join(googsystray.cache_dir, self.account["name"], contact["image"]["etag"])
		except:
			return os.path.join(googsystray.BASE_DIR, "icons", "Unknown-Portrait.png")
	

	def make_contact_image(self, contact, size, window):
		try:
			pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.cache_dir, self.account["name"], contact["image"]["etag"]))
			# Fallback to default pixmap just in case
		except:
			pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.BASE_DIR, "icons", "Unknown-Portrait.png"))
			
		if pb.get_width() == size and pb.get_height() == size:
			image = gtk.image_new_from_pixbuf(pb)
		elif pb.get_height() == size or pb.get_width() == size:
			pb2 = gtk.gdk.Pixbuf(pb.get_colorspace(), pb.get_has_alpha(), pb.get_bits_per_sample(), size, size)
			pb2.fill(0xffffffff)
			pb.copy_area(0, 0, pb.get_width(), pb.get_height(), pb2, 0, 0)
			image = gtk.image_new_from_pixbuf(pb2)
		else:
			# pb.get_width() == pb.get_height():
			pb2 = pb.scale_simple(size, size, gtk.gdk.INTERP_HYPER)
			image = gtk.image_new_from_pixbuf(pb2)
			
		if contact is not None:
			ebox = gtk.EventBox()
			ebox.add(image)
			ebox.set_events(gtk.gdk.BUTTON_PRESS_MASK |
					  gtk.gdk.ENTER_NOTIFY_MASK |
					  gtk.gdk.LEAVE_NOTIFY_MASK)
			ebox.set_visible_window(False)
			ebox.connect("enter_notify_event", self.icon_enter)
			ebox.connect("leave_notify_event", self.icon_leave)

			ebox.connect("button_press_event", self.contact_clicked, (contact, size, window))
			return ebox
			
		return image
			

	def check_data(self):
		if self.account["name"] not in self.auth or self.auth[self.account["name"]] == None:
			self.get_auth(self.account, 'cp')
			
		headers = {"Authorization" : self.auth[self.account["name"]],
			   "GData-Version" : "3"}
		
		url = "http://www.google.com/m8/feeds/contacts/default/full?max-results=10000"
		if self.updatedTime != None:
			url += "&updated-min=" + self.updatedTime
			
		data = self.urlopen2(self.account, url, headers=headers)

		if data == None:
			return
			
		try:
			root = ET.XML(data)
		except:
			# This is typically a temporary condition.
			googsystray.error("XML Error")
			return True

		for i in root.getchildren():
			if i.tag == _w05+"updated":
				self.updatedTime=i.text
			if i.tag == _w05+"entry":
				self.getEntry(i)


		self.phoneContacts = []
		for i in self.contacts.items():
			
			if i[1]["phone"] == []:
				continue;
			inserted = False
			pos = 0
			for j in self.phoneContacts:
				if j["title"] > i[1]["title"]:
					inserted = True
					self.phoneContacts.insert(pos, i[1])
					break
				pos+=1
			if not inserted:
				self.phoneContacts.append(i[1])


		if not os.path.exists(googsystray.cache_dir):
			os.makedirs(googsystray.cache_dir)
		os.chmod(googsystray.cache_dir, stat.S_IRWXU)

		cdir = os.path.join(googsystray.cache_dir, self.account["name"])

		if not os.path.exists(cdir):
			os.makedirs(cdir)
		os.chmod(cdir, stat.S_IRWXU)


		
		for i in self.contacts.items():
		
			if i[1]["image"] == {}:
				continue
				
			portrait = os.path.join(cdir, i[1]["image"]["etag"])
			if not os.path.exists(portrait):

				data = self.urlopen2(self.account, i[1]["image"]["href"], headers=headers)
				if data == None:
					continue
				
				pf = open(portrait, "wb")
				pf.write(data)
				pf.close()
			
		dirlist = os.listdir(cdir)
		for i in dirlist:
			nukeit=True
			
			for j in self.contacts.items():
				try:
					if j[1]["image"]["etag"] == i:
						nukeit=False
						break
				except KeyError, e:
					pass
				
			if nukeit:
				os.remove(os.path.join(cdir, i))


		return True
		
	def set_account(self, acct):
		self.config = "contacts-" + acct["name"]
		self.account = acct

	def stop(self):
		self.stop_timer()
		return

	def start(self):
		self.start_timer()
		

	def __init__ (self):
		GBase.GBase.__init__(self)
		# 15 minutes
		self.account = None
		self.timeout = 15*60000
		self.updatedTime = None
		self.contacts = {}
		self.phoneContacts = []
		self.config = "contacts"
		
