# -*- coding: utf-8 -*-

import gtk, gobject
import threading
import copy
import json
import types
import os

client_version=12743913


from xml.etree import cElementTree as ET
from GIcon import GIcon	

import googsystray
import GMain
import GPopupWindow

class GTasksList:
	def add_event(self, account, title, notes=None, date=None):
		entity_delta = { "name": title,
				 "creator_id": None,
				 "entity_type": "TASK" }
		if notes is not None:
			entity_delta["notes"] = notes
		if date is not None:
			entity_delta["task_date"] = date

		create = { "action_list": [ { "action_type": "create",
					      "action_id" : 8,
					      "index" : 1,
					      "entity_delta": entity_delta,
					      "parent_id": self.id,
					      "dest_parent_type": "GROUP",
					      "list_id": self.id,
					  } ],
			   "client_version": client_version,
			}
			
		headers = {"Authorization" : self.tasks_icon.auth[account["name"]],
		           "AT": "1" }
		if account["type"] == "Apps":
			url = "https://mail.google.com/tasks/a/" + account["domain"] + "/r/d"
		else:
			url = "https://mail.google.com/tasks/r/d"

		data = json.loads(self.tasks_icon.send_post_block(account, url, headers=headers, post_data=("r="+json.dumps(create))))
		self.tasks_icon.check_now()
					     

	def update_list(self, account):
		get_all = { "action_list": [ { "action_type": "get_all",
					       "action_id": 23,
					       "list_id": self.id,
					       "get_deleted": False,
					   } ],
			    "client_version": client_version
			  }
		headers = {"Authorization" : self.tasks_icon.auth[account["name"]],
		           "AT": "1" }
		if account["type"] == "Apps":
			url = "https://mail.google.com/tasks/a/" + account["domain"] + "/r/d"
		else:
			url = "https://mail.google.com/tasks/r/d"
			
		str = self.tasks_icon.urlopen2(account, url, headers=headers, post_data=("r="+json.dumps(get_all)))
		data = json.loads(str)


		for i in data["lists"]:
			if i["id"] == self.id:
				self.last_modified = i["last_modified"]
				break

		self.tasks = data
		
		           
	
	def __init__ (self, tasks, id, name):
		self.tasks_icon = tasks
		self.tasks = []
		self.id = id
		self.name = name
		self.last_modified = 0


class GTasks(GIcon):
		
	

	def icon_check_data(self, account):
		if account["name"] not in self.auth or self.auth[account["name"]] == None:
			self.get_auth(account, 'goanna_mobile')

		headers = {"Authorization" : self.auth[account["name"]] }
		if account["type"] == "Apps":
			base_url = "https://mail.google.com/tasks/a/" + account["domain"] + "/ig"
		else:
			base_url = "https://mail.google.com/tasks/ig"
			
		data = self.urlopen2(account, base_url, headers=headers);

		cst = data.find("_setup({") + len("_setup(")
		cend = data.rfind("}")
		struct = json.loads(data[cst:cend-1])

		try:
			old_lists = self.lists[account["name"]]
		except:
			old_lists = []
			
		self.lists[account["name"]] = []

		for i in struct["t"]["lists"]:
			found = False
			for j in old_lists:
				if j.id == i["id"]:
					self.lists[account["name"]].append(j)
					if i["last_modified"] > j.last_modified:
						j.update_list(account)
					found = True
						
						
			if not found:
				gtl = GTasksList(self, i["id"], i["name"])
				self.lists[account["name"]].append(gtl)
				gtl.update_list(account)
		return True
		
	def new_task_create(self, widget, account):
		self.new_task_create_button.set_sensitive(False)
		# Creating a new task
		self.new_task_create_button.set_label(_("Creating..."))

		date = None
		try:
			(year, month, day) = self.new_task_window.window.get_data("date")
			date = str(year)+str(month+1).zfill(2)+str(day).zfill(2)
		except:
			pass
			
		tb = self.new_task_notes_textview.get_buffer()
		(start, end) = tb.get_bounds()
		note = tb.get_text(start, end)
		if len(note) == 0:
			note = None
				
		liststore = self.new_task_list_entry.get_model()
		active = self.new_task_list_entry.get_active()
		for i in self.lists[account["name"]]:
			if i.id == liststore[active][1]:
				i.add_event(account, self.new_task_title_entry.get_text(), notes=note, date=date)

				
		if self.new_task_window != None:
			self.new_task_window.destroy()
			self.new_task_window = None
			return
			
	def new_task_calendar(self, widget, popup):
		dialog = gtk.Dialog(_("Select Date"), popup.window, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT, gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		
		date = popup.window.get_data("date")
			
		calendar = gtk.Calendar()
		
		if date is not None:
			(year, month, day) = date
			calendar.select_month(month, year)
			calendar.select_day(day)
		
		dialog.vbox.pack_start(calendar, False, False, 5)
		calendar.show()
		
		if dialog.run() == gtk.RESPONSE_ACCEPT:
			popup.window.set_data("date", calendar.get_date())
			
		dialog.destroy()


	def new_task_cbox_toggled(self, widget, data):
		if widget.get_active():
			self.new_task_hbox.show_all()
		else:
			self.new_task_hbox.hide_all()
		
		
	def new_task_draw(self, account, vbox, contact=None):
		hbox = gtk.HBox()
		
		# Select which task list to use
		label = gtk.Label("List:")
		hbox.pack_start(label, False, False, 2)
		liststore = gtk.ListStore(str, str)
		
		for i in self.lists[account["name"]]:
			liststore.append([i.name, i.id])
		
		self.new_task_list_entry = gtk.ComboBox(liststore)
		cell = gtk.CellRendererText()
		self.new_task_list_entry.pack_start(cell, True)
		self.new_task_list_entry.add_attribute(cell, 'text', 0)
		self.new_task_list_entry.set_active(0)
		
		hbox.pack_start(self.new_task_list_entry, True, True, 2)
		vbox.pack_start(hbox, False, False, 2)
		hbox.show_all()


		hbox = gtk.HBox()	
		# This is for the title of a new task	
		label = gtk.Label(_("Title:"))
		hbox.pack_start(label, False, False, 2)
		vbox.pack_start(hbox, False, False, 2)
		self.new_task_title_entry = gtk.Entry()
		hbox.pack_start(self.new_task_title_entry, True, True, 5)
		button = gtk.Button()
		pb = gtk.gdk.pixbuf_new_from_file(os.path.join(googsystray.BASE_DIR, "icons", "Google-Calendar-64.png"))
		pb2 = pb.scale_simple(24, 24, gtk.gdk.INTERP_HYPER)
		image = gtk.image_new_from_pixbuf(pb2)
		button.set_image(image)
		button.connect("clicked", self.new_task_calendar, self.new_task_window)
		hbox.pack_end(button, False, False, 5)
		hbox.show_all()
		
		
		self.new_task_hbox = gtk.HBox()
		vbox.pack_start(self.new_task_hbox, True, True, 5)
		
		label = gtk.Label(_("Notes:"))
		self.new_task_hbox.pack_start(label, False, False, 5)
		self.new_task_notes_textview = gtk.TextView()
		self.new_task_notes_textview.set_size_request(-1, 80)
		self.new_task_hbox.pack_start(self.new_task_notes_textview, True, True, 5)
		self.new_task_hbox.hide_all()

		hbox = gtk.HBox()
		cbox = gtk.CheckButton(_("Add Notes"))
		hbox.pack_start(cbox, False, False, 5)
		cbox.connect("toggled", self.new_task_cbox_toggled, None)
		self.new_task_create_button = gtk.Button(_("Create Task"))
		hbox.pack_end(self.new_task_create_button, False, False, 5)
		hbox.show_all()
		vbox.pack_start(hbox, False, False, 5)
		
		self.new_task_title_entry.connect("activate", self.new_task_create, account)
		self.new_task_create_button.connect("clicked", self.new_task_create, account)
		
		vbox.show()
		
		return

	def new_task_destroy(self):
		self.new_task_window = None
		return

	def new_task(self, data1=None, data2=None, contact=None):
		if self.new_task_window != None:
			self.new_task_window.destroy()
			self.new_task_window = None
			return
			
			
		# FIXME we should probably actually support WHICH account to open...
		acct = None
		for i in GMain._accounts:
			if i["services"]["gtasks"]:
				acct = i
				break
		
		# Nothing, if no account is GV-enabled.  
		if acct is None:
			return 

		self.new_task_window = GPopupWindow.get_new_popup_window(self.new_task_destroy, 
		                                                        _("New Task"),
		                                                        icon=os.path.join(googsystray.BASE_DIR, "icons", self.get_config()["icon"]))
		                                                        
		self.new_task_window.window.set_default_size(int(400*self.get_gconfig()["popup_size"]),-1)
		self.new_task_draw(acct, self.new_task_window.vbox, contact=contact)
		self.new_task_window.show()

	def add_menu_items(self, menu):
		GIcon.add_menu_items(self, menu)
		menuItem = gtk.MenuItem(_("Create New Task"))
		menuItem.connect("activate", self.new_task)
		menu.append(menuItem)
		
		
	def icon_stop(self):
		self.unbind_hotkey("new_task")

	def icon_start(self):
		self.bind_hotkey("new_task", self.new_task, None)
		
		
	def __init__(self):
		self.config = "gtasks"
		self.auth = {}
		self.lists = {}
		self.new_task_window = None
		
		GIcon.__init__(self)
